/*
 * try_demo.h
 *
 * exception handling example.
 *
 * author: Michael Stickel <michael@cubic.org>
 * date:   12.11.2000
 */
#include <stdio.h>

#include <trycatch.h>



int function_with_try()
{
  cause_t cause2;

  TRYwith(cause2)
    {
      void (*func) () = NULL;
      printf ("entering crashing function call: envsp=%d\n", env_sp);
      func();
      printf ("leaving crashing function call\n");
    }
  CATCH
    {
      printf ("resume from failed function call\n");
      return 1;
    }
  return 0;
}


int main ()
{
  cause_t cause;

  int *xp = NULL;
  int x=0;

  printf ("------------ a very short try-catch ---------------\n");

  TRY x = *xp; CATCH x = 10;

  printf ("x=%d\n", x);


  printf ("------------- a try catch which gives the cause for the crash -------\n");
  TRYwith(cause)
  {
    int i=0;
    int j = 10/i;
  }
  CATCH
  {
     printf ("got a %s\n", (cause==SIGFPE)?"SIGFPE":(cause==SIGSEGV)?"SIGSEGV":"SIG-unknown");
  }


  printf ("---------- some cascaded try-catch -------------\n");
  TRY
    {
      printf ("function_with_try() = %d\n", function_with_try());

      printf ("entering crashing code\n");
      *((char *)0x11111111) = 11;
      printf ("leaving crashing code\n");

    }
  CATCH
    {
      printf ("resume from failed try\n");

      TRY
      {
        printf ("entering crashing second code\n");
        *((char *)0x22222222) = 22;
        printf ("leaving crashing second code\n");
      }
      CATCH
      {
        printf ("resume from failed second try\n");
      }

    }

  printf ("at end\n");
}



