/*
 * trycatch.c
 *
 * some exception handling in plain C.
 *
 * author: Michael Stickel <michael@cubic.org>
 * date:   12.11.2000
 */

#include <stdio.h>

#include <trycatch.h>

int   env_sp = 0;
trycatch_stackelem_t __trycatchstack[100]; /* should be dynamicly allocated */


void compute_sigv (int sig)
{
  if (env_sp>0)
    {
      env_sp--;
      signal (SIGSEGV, __trycatchstack[env_sp].sig_SIGSEGV);
      signal (SIGFPE, __trycatchstack[env_sp].sig_SIGFPE);
#if 0
      signal (SIGPIPE, __trycatchstack[env_sp].sig_SIGPIPE);
#endif
      siglongjmp (__trycatchstack[env_sp].env, sig);
    }
  printf ("FATAL: unrecoverable failed catch: try stack underflow\n");
  exit(0);
}


